// invitation.h
// collect eMail addresses of to-be-invited friends
// 
// v0.98 (3.5.2002)
// (c) 2002 Andreas Krueger
//
// Please, if you change anything in this code,
// mark the end of those lines with '// *+* your name *+* ' 
// (so that I can find it) and send the code 
// to cye-code@AndreasKrueger.de
//
// last change: 
//          by:

#ifndef INVITATION_H
#define INVITATION_H

//#include "classes.h"
#include "constants.h"
#include "slideshow.h"

#include <qmessagebox.h>
#include <qpixmap.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qvbox.h>
#include <qstring.h>
#include <qlcdnumber.h>
#include <qcolor.h>
#include <qpoint.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qgrid.h>
#include <qcolor.h>
#include <qapplication.h>
#include <qprogressdialog.h>
#include <qtextstream.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qgroupbox.h>

#include <string>
using std::string;

class InvitedPerson{
public:
	string name;
	string email;
	Q_UINT8 coin;
	bool uploaded;
	
	InvitedPerson(string n="", string e="", Q_UINT8 c=0, bool u=false) 
		: name(n), email(e), coin(c), uploaded(u) {};

	void fromListViewItem(QListViewItem *i);
	QListViewItem* toListViewItem(QListView * parent);

	friend void fromListViewToValueList(QListView *LV, QValueList<InvitedPerson > &lip);
	friend void fromValueListToListView(QValueList<InvitedPerson > &lip, QListView *LV);

	friend QTextStream& operator<<(QTextStream &s, QValueList<InvitedPerson > &lip);
	friend QDataStream& operator<<(QDataStream &s, QValueList<InvitedPerson > &lip);
	friend QDataStream& operator>>(QDataStream &s, QValueList<InvitedPerson > &lip);
	friend char* printTheNotYetUploadedIntoSQLTriple(QValueList<InvitedPerson > &lip, 
		                                  string fourthcolumn, int &NumNotYetUploaded);
	friend void setAllUploadedTrue(QValueList<InvitedPerson > &lip);
};


////////////////////////////////////////// 
// class Invitations
//    the Dialogwindow and the ListView!
//////////////////////////////////////////

class Invitations : public QHBox{
	Q_OBJECT
public:
	SlideShow *theCoinShow;
	Invitations( QWidget *parent, const char *name );
	void writeInvitedPersonsToStream(QTextStream& qts);
	void writeInvitedPersonsToStream(QDataStream& qds);
	void setFavouriteCoin(uint CoinNumber);
	QListView	*invited;

private:
	QLineEdit	*editname;
	QLineEdit	*editemail;
	QLineEdit	*editcoin;
	QLabel		*info;
	QLabel		*labfav;

public slots:

protected slots:

private slots:
	void CoinChanged();
	void insertPerson();
	void removePerson();
	void test();
	void processEvents(QString);
	
signals:
	void ok();
	void Event(QString);
};


#endif // INVITATION_H




